<?php
namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\Sm00035000MaximoCarenciaPropostaPerfilAcessoFactory;
use Teknisa\Libs\Util\Environment;

class Sm00035000MaximoCarenciaPropostaPerfilAcessoService
{
    
    protected $FactoryCarenciaPerfProp;
    protected $Environment;
    
    public function __construct (Sm00035000MaximoCarenciaPropostaPerfilAcessoFactory $FactoryCarenciaPerfProp, Environment $Environment){
        
        $this->FactoryCarenciaPerfProp  = $FactoryCarenciaPerfProp;
        $this->Environment  = $Environment;

    }
    
     /**
     * A função "validaCarenciaOperador" verifica se já existe 
     * uma carencia cadastrada para o operador indicado.
     */
     
    public function validaCarenciaPerfilAcesso($perfAcesso){
    
        $paramsValidaCarenciaPerfProp = array(
            "NRPERFILACESSO"  => $perfAcesso,
            "NRORG"          => $this->Environment->getNrOrg()
        );
        
        $returnValidaCarenciaPerProp = $this->FactoryCarenciaPerfProp->validaCarenciaPerfilAcesso($paramsValidaCarenciaPerfProp);
        
        return $returnValidaCarenciaPerProp[0]["VALIDAPERF"] != 0;
        
    }

}
?>