/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: CALCULA_PREVCONS_FILIAIS

Descrio:
Clculo da Previso de Consumo p/ filiais

P_CDFILIAL     - Lista de filiais
P_TCDFILIAL    - Todas as filiais
P_GRUPFILI     - Agrupamento de Filial
P_DTFINAL      - Data final de clculo
P_PEACRESCIMO  - Percentual de acrscimo
P_CDPRODUTOINI - Cdigo do produto inicial (CDARVPROD)
P_CDPRODUTOFIN - Cdigo do produto final   (CDARVPROD)
P_CDOPERADOR   - Cdigo do operador que solicitou o clculo
P_DTHRCALCPC   - Data/hora do clculo
P_STDTINICIAL  - Lista de data inicial (em string) por servio
P_STDTFINAL    - Lista de data final (em string) por servio
Para aplicar e debugar
 @C:\WIN_V4\SQL\END_CONV\ORACLE\7135_PLASTPO.SQL;

Criao:
07/04/2004 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE
PROCEDURE SF_CALCULA_PREVCONS_FILIAIS
  (P_CDFILIAL     IN VARCHAR2,
   P_TCDFILIAL    IN VARCHAR2,
   P_CDGRUPFILI   IN VARCHAR2,
   P_DTFINAL      IN DATE,
   P_PEACRESCIMO  IN NUMBER,
   P_CDPRODUTOINI IN VARCHAR2,
   P_CDPRODUTOFIN IN VARCHAR2,
   P_CDOPERADOR   IN VARCHAR2,
   P_DTHRCALCPC   IN DATE,
   P_IDARREDOND   IN VARCHAR2,
   P_STDTINICIAL  IN VARCHAR2 DEFAULT NULL,
   P_STDTFINAL    IN VARCHAR2 DEFAULT NULL,
   P_NRORG        IN PREVCONS.NRORG%TYPE DEFAULT 1) IS

   V_DATAPROC  DATE;
   V_IDUTILDTPROC VARCHAR2(1);
   V_PRXCONSPLAN VARCHAR2(20);
   V_CDPRODUTOFIN VARCHAR2(50);

BEGIN
   V_IDUTILDTPROC := '';
   SELECT
      MAX(IDUTILDTPROC)
   INTO
      V_IDUTILDTPROC
   FROM
      PARAMGERAL
   WHERE PARAMGERAL.NRORG=P_NRORG;

   FOR CUR_FILIAL IN
      (SELECT
          FILIAL.CDFILIAL
       FROM
          FILIAL
       WHERE
          (INSTR(P_CDFILIAL, FILIAL.CDFILIAL) > 0 OR P_TCDFILIAL = 'T') AND
          (P_CDGRUPFILI IS NULL)                                        AND
          (NRORG = P_NRORG)
       UNION ALL
       SELECT
          FILGRUPFILI.CDFILIAL
       FROM
          FILGRUPFILI
       WHERE
          (INSTR(P_CDFILIAL, FILGRUPFILI.CDFILIAL) > 0 OR P_TCDFILIAL = 'T') AND
          (FILGRUPFILI.CDGRUPFILI = P_CDGRUPFILI)                            AND
          (NRORG = P_NRORG)                     )                           
   LOOP
      V_PRXCONSPLAN  := '';
      V_CDPRODUTOFIN := '';
      V_CDPRODUTOFIN := P_CDPRODUTOFIN;

/* - Verifica a data de processamento para a filial informada ------------ */
      IF V_IDUTILDTPROC <> 'S' THEN
         V_DATAPROC := TRUNC(SYSDATE);
      ELSE
         SELECT
            MAX(NVL(DTPROCESSA, TRUNC(SYSDATE)))
         INTO
            V_DATAPROC
         FROM
            PARAMFILIAL
         WHERE CDFILIAL = CUR_FILIAL.CDFILIAL
           AND NRORG = P_NRORG;
      END IF;

      NOVO_CODIGO('CONSPLAN'||CUR_FILIAL.CDFILIAL, V_PRXCONSPLAN, 1, P_NRORG);
      V_PRXCONSPLAN := SUBSTR(V_PRXCONSPLAN,11,10);
      SF_PREVISAO_DE_CONSUMO_PLA(CUR_FILIAL.CDFILIAL,
                                 'T', /*P_CDSERVFILI :  Sempre sero todos os servios*/
                                 V_DATAPROC,
                                 P_DTFINAL,
                                 P_PEACRESCIMO,
                                 P_CDPRODUTOINI,
                                 V_CDPRODUTOFIN,
                                 P_CDOPERADOR,
                                 P_DTHRCALCPC,
                                 V_PRXCONSPLAN,
                                 P_IDARREDOND,
                                 P_STDTINICIAL,
                                 P_STDTFINAL,
                                 P_NRORG);
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SF_CALCULA_PREVCONS_FILIAIS','5.01.001'); END;
/

